/// <reference types="@types/node" />
import { IResolvers } from 'graphql-tools';
import { Server as HttpServer } from 'http';
import { GraphQLSchema } from 'graphql';
import { GraphQLServerOptions as GraphQLOptions } from './graphqlOptions';
import { Config, ListenOptions, RegistrationOptions, ServerInfo } from './types';
export declare class ApolloServerBase {
    disableTools: boolean;
    subscriptionsPath: string;
    requestOptions: Partial<GraphQLOptions<any>>;
    private schema;
    private context?;
    private graphqlPath;
    private engineReportingAgent?;
    private engineProxy;
    private extensions;
    private http?;
    private subscriptionServer?;
    protected getHttp: () => HttpServer;
    constructor(config: Config);
    use({ getHttp, path }: RegistrationOptions): void;
    enhanceSchema(schema: GraphQLSchema | {
        typeDefs: string;
        resolvers: IResolvers;
    }): void;
    listen(opts?: ListenOptions): Promise<ServerInfo>;
    stop(): Promise<void>;
    private createSubscriptionServer;
    private createEngine;
    protected graphQLServerOptions(integrationContextArgument?: Record<string, any>): Promise<GraphQLOptions<Record<string, any> | (() => Record<string, any> | Promise<Record<string, any>>)>>;
}
